#!/usr/local/bin/perl

require './jcode.pl';
require './init.cgi';
require './subr1.cgi';
require './cookie.cgi';

$bbsname = "list.cgi";

&getSetup(2); # ݒǂݍ(1=Ǎ㏉)
&getData($basefile);
&getData($colorFile); # panel,gamen1`4{bgcolor,textcolor,linkcolor,barbgcolor,bartextcolor}

$yen = $setup{'yen'};
@zeiTable = ("&lt;O&gt;","&lt;&gt;");
$tanni = $zeiTable[$setup{'zei'}];

require './setcolor.cgi';
&readColor;

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
if ($ENV{'QUERY_STRING'} ne '') { $buffer .= "\&$ENV{'QUERY_STRING'}"; }

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {

	($name,$value) = split(/=/,$pair);

	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	&jcode'convert(*value,'sjis');

	$value =~ s/&/&amp;/g;
	$value =~ s/"/&quot;/g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;

	$value =~ s/\t//g;
	$value =~ s/\r\n/\n/g; # Win  Unix
	$value =~ s/\r/\n/g; # Mac  Unix

	$in{$name} .= "\0" if (defined($in{$name}));
	$in{$name} .= $value;
}

if ($in{'category'} ne "") {

	if ($in{'category'} ne "default" && !defined($cateName{$in{'category'}})) { &error("̑̃G[","̂悤ȃJeS[͂܂B"); }
}

if ($in{'cmd'} eq "logout") {

	require './cookie.cgi'; # NbL[EOCǗ
	&logout;
}

$in{'file'} =~ s/\D//g;
$in{'filename'} =~ s/\.\.//g;

if ($in{'cmd'} eq "remember") { require './list2.cgi'; require './cookie.cgi'; &rememberPut(); exit; }
elsif ($in{'cmd'} eq "reviews") { require './list3.cgi'; &review("$in{'category'}/$in{'file'}"); exit; }
elsif ($in{'cmd'} eq "review_reg") { require './list3.cgi'; &review_reg("$in{'category'}/$in{'file'}"); exit; }
elsif ($in{'cmd'} eq "review_del") { require './list3.cgi'; &review_del("$in{'category'}/$in{'file'}"); exit; }
elsif ($in{'file'} ne "") { require './list2.cgi'; &viewFile("$in{'category'}/$in{'file'}"); exit; }
elsif ($in{'cmd'} eq "tokushoho" || $in{'cmd'} eq "payment") { require './list2.cgi'; &viewMado($in{'cmd'}); exit; }
elsif ($in{'cmd'} eq "img") { require './list2.cgi'; &viewImage($in{'filename'}); exit; }
elsif ($in{'cmd'} eq "img2") { require './list2.cgi'; &viewImageHTML($in{'filename'}); exit; }

if ($in{'cmd'} eq "memory") {

	require './list2.cgi';
	require './cookie.cgi';
	($rememberID) = &decCookie("remember");
	&viewList("ۗXgɒǉ","");
}
else {
	&getCate;

	if (! -e $cateFile || ! $in{'cate'}) { $in{'category'} = $searchDir = "default"; }
	else { $searchDir = ""; }

	if ($in{'category'} ne "") { $page = $goods_page; $viewTitle = "ïꗗ"; }
	else { $page = $cate_page; $viewTitle = "iJeS"; }

	$target = $goods_dir . $in{'category'};
	&viewList($viewTitle,$target);
}

sub viewList {

	local($viewTitle,$targetDir) = @_;

	@BASE = @list = ();

	if ($in{'cmd'} eq "search") { # i

		if ($in{'str'} eq "" || $in{'str'} =~ / |\,|\;|\"/) { &error("G[","镶PP͂ĂB","L͊܂߂ȂłB"); }

		$check = (eval { opendir(DIR,$targetDir); }, $@ eq "");
		if (!$check) { &error("vIȃG[","Can't get directory"); }

		@list = readdir(DIR);
		close(DIR);

		@list = sort { $b <=> $a; } @list;

		if ($targetDir =~ /default$/) {

			$category = "default";
			foreach $filename (@list) {

				if (! open(F,"$goods_dir$category/$filename/index.cgi")) { next; }
				@lines = <F>;
				close(F);

				undef %search;
				foreach $line (@lines) {

					$line =~ s/\n//g;
					($key,$val) = split(/\t/,$line,2);
					if ($key eq "Honbun") { $honbun{$category}{$filename} = $val; }
					if ($key eq "Title") { $title{$category}{$filename} = $val; }
				}
			}
		}
		else {
			foreach $category (@list) {

				next if $category eq '.';
				next if $category eq '..';

				if ($searchDir eq "" && $category eq "default") { next; }
				if ($in{'category'} eq "" && $cateName{$category} eq "") { next; }

				if (-d "$targetDir/$category/") {

					opendir(DIR,"$targetDir/$category/");
					@array = readdir(DIR);
					close(DIR);

					foreach $filename (@array) {

						if (! open(F,"$goods_dir$category/$filename/index.cgi")) { next; }
						@lines = <F>;
						close(F);

						undef %search;
						foreach $line (@lines) {

							$line =~ s/\n//g;
							($key,$val) = split(/\t/,$line,2);
							if ($key eq "Honbun") { $val = &Text2Tag($val); $honbun{$category}{$filename} = $val; }
							if ($key eq "Title") { $title{$category}{$filename} = $val; }
						}
					}
				}
			}
		}

		$str = $in{'str'};
		&jcode'convert(*str,'euc'); # p

		if ($in{'searchTarget'} eq "honbun") {

			foreach $cat (sort keys %honbun) {

				foreach $num (sort keys %{ $honbun{$cat} }) {

					$base = $honbun{$cat}{$num};
					&jcode'convert(*base,'euc');
					if ($base =~ /^([\x00-\x7F]|[\x8E\xA1-\xFE][\xA1-\xFE]|\x8F[\xA1-\xFE]{2})*$str/i) { $done{$cat}{$num} = 1; push(@BASE,"$cat\t$num"); }
				}
			}
		}

		foreach $cat (sort keys %title) {

			foreach $num (sort keys %{ $title{$cat} }) {

				$base = $title{$cat}{$num};
				&jcode'convert(*base,'euc');
				if ($base =~ /^([\x00-\x7F]|[\x8E\xA1-\xFE][\xA1-\xFE]|\x8F[\xA1-\xFE]{2})*$str/i) {

					if ($done{$cat}{$num}) { next; }
					push(@BASE,"$cat\t$num");
				}
			}
		}

		if (!@BASE) { &error("","\"$in{'str'}\"ł͒o܂łB"); }
		@BASE = reverse @BASE;

		sub Text2Tag
		{
			local($value) = @_;
			$value =~ s/&amp;/&/g;
			$value =~ s/&quot;/"/g;
			$value =~ s/&lt;/</g;
			$value =~ s/&gt;/>/g;
			$value;
		}
	}
	elsif ($in{'cmd'} eq "memory") { # ۗXgɒǉ

		$page = $goods_page;

		$rememberID =~ s/\D//g;
		if (open(RID,"$tmp_dir$rememberID")) {

			while(<RID>) {

				s/\n//g;
				($category,$file) = split(/\t/,$_,2);
				push(@BASE,"$category\t$file");
			}

			close(RID);
		}

		@BASE = reverse @BASE;
	}
	elsif ($in{'category'} ne "") { # iXg

		if (!-e $targetDir) { &error("G[","T̃y[W܂B"); }

		$check = (eval { opendir(DIR,$targetDir); }, $@ eq "");
		if (!$check) { &error("vIȃG[","Can't get directory"); }

		@list = readdir(DIR);
		@list = sort { $b <=> $a; } @list;

		foreach $dir (@list) {

			next if $dir eq '.';
			next if $dir eq '..';

			if ($searchDir eq "" && $dir eq "default") { next; }
			if ($in{'category'} eq "" && $cateName{$dir} eq "") { next; }
			if (-d "$targetDir/$dir/") { push(@BASE,$dir); }
		}

		close(DIR);
	}
	else { # JeS[Xg

		if (!-e $targetDir) { &error("G[","T̃y[W܂B"); }

		foreach $dir (@addCateValue) {

			next if $dir eq '.';
			next if $dir eq '..';

			if ($searchDir eq "" && $dir eq "default") { next; }
			if ($in{'category'} eq "" && $cateName{$dir} eq "") { next; }
			if (-d "$targetDir/$dir/") { push(@BASE,$dir); }
		}
	}

	if ($in{'category'} ne "" && $in{'cmd'} ne "memory" && $in{'cmd'} ne "search") {

		if ($in{'ff'} eq '') { $FF = 0; } else { $FF = $in{'ff'}; }
		$TO = $FF + $page - 1;
		if ($TO > $#BASE) { $TO = $#BASE; }
		$hit = 0;
		$next_num = '';

		foreach $num ($FF .. $#BASE) {

			$filename = $BASE[$num];

			if ($in{'ff'} ne '') {

				$allhits = $in{'allhits'};
				if ($hit == $page) { last; }
				else { push(@NEW,$filename); $hit++; }
			}
			else {
				if ($hit < $page) { $hit++; push(@NEW,$filename); }
				$allhits++;
			}
		}

		$in{'allhits'} = $allhits;
		$count_new = @NEW;

		if ($in{'allhits'} == 0) {

			if ($in{'cmd'} eq "memory") { &error("ۗXg","ꗗ͂܂B"); }
			else { &error("G[","T̈ꗗ͂܂B"); }
		}
	}
	else { @NEW = @BASE; }

	if (open(F,$infoFile)) {

		@INFO = <F>;
		close(F);

		foreach $i (@INFO) {

			$i =~ s/\n//g;
			($key,$val) = split(/\t/,$i,2);
			$setup{$key} .= "\n" if (defined($setup{$key}));
			$setup{$key} .= $val;
		}

		$main = &tag_ok($setup{'main'});
		$head = &tag_ok($setup{'head'});
		$mid = &tag_ok($setup{'mid'});
		$foot = &tag_ok($setup{'end'});
	}

	if (-e "$tmp_dir$logofile") {

		if (open(F,"$tmp_dir$logoType")) {

			$ctype = <F>;
			close(F);
		}

		$LOGO = "<td align=right><img src=\"panel.cgi?cmd=img3&filename=LOGO&ctype=$ctype\" alt=\"LOGO\"></td>";
	}

print &HtmlTop("bgcolor=#FFFFFF");

print <<"EOF";
<br>

<SCRIPT language="JavaScript">
<!--
function popup(){
window.open("","popup","location=no,status=no,toolbar=no,menubar=yes,scrollbars=yes,resizable=yes,width=550,height=450");
}
//-->
</SCRIPT>

<center>
$LOGO

<table cellspacing=0 width=80%>
<tr><td>$head</td></tr>
<tr><td><img src="$setup{'htdocs_url'}sp.gif" height=1 alt=""></td></tr>
</table>

<STYLE type="text/css">
<!--
a.n:link { color:#$linkcolor{'panel'} }
a.n:visited { color:#$linkcolor{'panel'} }
a.n:hover { color:#$linkcolor{'panel'} }
a.n:active { color:#$linkcolor{'panel'} }
a.n2:link { color:#ffffff }
a.n2:visited { color:#ffffff }
a.n2:hover { color:#ffffff }
a.n2:active { color:#ffffff }
-->
</STYLE>

<!-- /* TopicWindow -->
<table cellpadding=0 cellspacing=0 border=0 width=80%>
<tr>
<td><table cellpadding=0 cellspacing=0 border=0>
<tr>
EOF

# ^u\
if ($in{'cmd'} eq "search") {

print <<"EOF";
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<a class=n2 href=list.cgi>ĩJeS</a></td>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<a class=n2 href=list.cgi?cmd=memory>ۗXg</a></td>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<form action="list.cgi?cmd=search" method=post>
<td bgcolor=#$barbgcolor{'panel'} height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#ffffff><small>i <input type=text name=str value="$in{'str'}" size=30><input type=checkbox name=searchTarget value="honbun" checked>܂߂</small></font> <input type=submit value=""></td></form>
<td valign=top bgcolor=#$barbgcolor{'panel'}><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
EOF

$colspan = 7;

}
elsif ($in{'cmd'} eq "memory") {

print <<"EOF";
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<a class=n2 href=list.cgi>ĩJeS</a></td>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<td bgcolor=#$barbgcolor{'panel'} height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#$bartextcolor{'panel'}>ۗXg</font></td>
<td valign=top bgcolor=#$barbgcolor{'panel'}><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<form action="list.cgi?cmd=search" method=post>
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#ffffff><small>i <input type=text name=str value="$in{'str'}" size=30><input type=checkbox name=searchTarget value="honbun" checked>܂߂</small></font> <input type=submit value=""></td></form>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
EOF

$colspan = 7;

}
elsif (! -e $cateFile || ! $in{'cate'}) {

print <<"EOF";
<td bgcolor=#$barbgcolor{'panel'} height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#$bartextcolor{'panel'}>$viewTitle</font></td>
<td valign=top bgcolor=#$barbgcolor{'panel'}><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<a class=n2 href=list.cgi?cmd=memory>ۗXg</a></td>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<form action="list.cgi?cmd=search" method=post>
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#ffffff><small>i <input type=text name=str value="$in{'str'}" size=30><input type=checkbox name=searchTarget value="honbun" checked>܂߂</small></font> <input type=submit value=""></td></form>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
EOF

$colspan = 7;

}
elsif ($in{'category'} ne "") {

print <<"EOF";
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<a class=n2 href=list.cgi>ĩJeS</a></td>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
<td bgcolor=#$barbgcolor{'panel'} height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#$bartextcolor{'panel'}>$cateName{$in{'category'}}</font></td>
<td valign=top bgcolor=#$barbgcolor{'panel'}><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<a class=n2 href=list.cgi?cmd=memory>ۗXg</a></td>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<form action="list.cgi?cmd=search" method=post>
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#ffffff><small>i <input type=text name=str value="$in{'str'}" size=30><input type=checkbox name=searchTarget value="honbun" checked>܂߂</small></font> <input type=submit value=""></td></form>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
EOF

$colspan = 9;

}
else {

print <<"EOF";
<td bgcolor=#$barbgcolor{'panel'} height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#$bartextcolor{'panel'}>$viewTitle</font></td>
<td valign=top bgcolor=#$barbgcolor{'panel'}><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<a class=n2 href=list.cgi?cmd=memory>ۗXg</a></td>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>

<form action="list.cgi?cmd=search" method=post>
<td bgcolor=#aaaaaa height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#ffffff><small>i <input type=text name=str value="$in{'str'}" size=30><input type=checkbox name=searchTarget value="honbun" checked>܂߂</small></font> <input type=submit value=""></td></form>
<td valign=top bgcolor=#aaaaaa><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
EOF

$colspan = 7;

}

print <<"EOF";
<td align=right width=99% bgcolor=#FFFFFF height=15 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=5 height=1 alt=""><font size=+1>[<a href=cart.cgi class=n>JS</a>]</font></td>
</tr>
<tr>
<td colspan=$colspan bgcolor=#$barbgcolor{'panel'} height=2></td>
</tr>
</table></td>
</tr>
<tr>
<td><table cellpadding=1 cellspacing=0 border=0 width=100%>
<tr bgcolor=#$barbgcolor{'panel'}>
<td><table cellpadding=10 cellspacing=0 border=0 width=100%>
<tr bgcolor=#$bgcolor{'panel'}>
<td>
<!-- /* TopicWindow Area-->
EOF

if ($in{'vp'} eq "") { $in{'vp'} = 1; }

$n = $vp = 0;
for ($jump = $page; $jump < $in{'allhits'} + $page; $jump += $page) {

	$vp++;
	$ffv = ($vp - 1) * $page;
	$last_page++;
}

$start = $in{'vp'} - 9;
if ($start < 1) { $start = 1; }

$end = $in{'vp'} + 9;
if ($end >= $last_page) { $end = $last_page; }

$n = $vp = 0;
foreach $vp ($start .. $end) {

	$ffv = ($vp - 1) * $page;
	$title = '';

	if ($vp == $in{'vp'}) { $page_now = $vp; last; }
}

$FROM = $page_now * $page - ($page - 1);
$LAST = $FROM + $count_new - 1;

if ($in{'mode'} eq "") { $in{'mode'} = 2; } # ftHgɂ鏤i\@ 0:摜Ȃ 1:摜 2:摜̂

if ($in{'category'} ne "" || $in{'cmd'} eq "memory" || $in{'cmd'} eq "search") {

	if ($in{'mode'} eq "1") { $mode = "&nbsp;[ <b>摜</b> ] [ <a href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$in{'vp'}&allhits=$in{'allhits'}&ff=$in{'ff'}&mode=0&str=$in{'str'}&searchTarget=$in{'searchTarget'}\" class=n>摜Ȃ</a> ] [ <a href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$in{'vp'}&allhits=$in{'allhits'}&ff=$in{'ff'}&mode=2&str=$in{'str'}&searchTarget=$in{'searchTarget'}\" class=n>摜̂</a> ]"; }
	elsif ($in{'mode'} eq "2") { $mode = "&nbsp;[ <a href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$in{'vp'}&allhits=$in{'allhits'}&ff=$in{'ff'}&mode=1&str=$in{'str'}&searchTarget=$in{'searchTarget'}\" class=n>摜</a> ] [ <a href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$in{'vp'}&allhits=$in{'allhits'}&ff=$in{'ff'}&mode=0&str=$in{'str'}&searchTarget=$in{'searchTarget'}\" class=n>摜Ȃ</a> ] [ <b>摜̂</b> ]<hr size=1>"; }
	else { $mode = "&nbsp;[ <a href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$in{'vp'}&allhits=$in{'allhits'}&ff=$in{'ff'}&mode=1&str=$in{'str'}&searchTarget=$in{'searchTarget'}\" class=n>摜</a> ] [ <b>摜Ȃ</b> ] [ <a href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$in{'vp'}&allhits=$in{'allhits'}&ff=$in{'ff'}&mode=2&str=$in{'str'}&searchTarget=$in{'searchTarget'}\" class=n>摜̂</a> ]"; }
}

if ($in{'cmd'} ne "memory") {

print <<"EOF";
<table width=100% cellpadding=0 cellspacing=0><tr><td bgcolor=#$bgcolor{'panel'} vAlign=top><font color=#$textcolor{'panel'}>$mid</font></td></tr></table>
<p>
EOF

}

print <<"EOF";
<small>$mode</small>
<Table cellspacing=1 cellpadding=1 width=100% border=0>
<tr><td><TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2 width=100%
<tr><td nowrap width=10%>

<table cellspacing=2 cellpadding=1 width=100%>
EOF

if (($in{'category'} ne "" || $in{'cmd'} eq "memory" || $in{'cmd'} eq "search") && ($in{'mode'} ne "1" && $in{'mode'} ne "2")) { # ïꗗ

print <<"EOF";
<tr bgcolor=#dddddd>
<td width=25 align=center nowrap><img src=\"$setup{'htdocs_url'}sp.gif\" width=25 height=1 alt=""><br><nobr><small><font color=#888888>ʐ^</font></small></nobr></td>
<td align=center><small><font color=#888888> i </font></small></td>
<td width=100 align=center><img src="$setup{'htdocs_url'}sp.gif" width=100 height=1 alt=""><br><small><font color=#888888>z $tanni</font></small></td>
</tr>
EOF

}

$colspan = 0;
if ($in{'mode'} eq "2") { print "<tr>\n"; }

$f = 0;
$f2 = $page;
@col = ("#f8f8f8","#ffffff");

foreach $filename (@NEW) {

	if ($in{'category'} ne "" || $in{'cmd'} eq "memory" || $in{'cmd'} eq "search") {

		if ($in{'cmd'} eq "memory" || $in{'cmd'} eq "search") { ($in{'category'},$filename) = split(/\t/,$filename,2); }

		$filename =~ s/\D//g;
		if (! open(F,"$goods_dir$in{'category'}/$filename/index.cgi")) { next; }

		@lines = <F>;
		close(F);

		undef %setup2;
		foreach $line (@lines) {

			$line =~ s/\n//g;
			($key,$val) = split(/\t/,$line,2);
			$setup2{$key} .= "\0" if (defined($setup2{$key}));
			$setup2{$key} .= $val;
		}

		$setup2{'Fee'} = &keta($setup2{'Fee'});

		if ($setup2{'Bold'}) { $bold1 = "<b>"; $bold2 = "</b>"; } # w
		else { $bold1 = $bold2 = ""; }

		$col++;

		if ($setup2{'img'}) {

			if ($in{'mode'} eq "1" || $in{'mode'} eq "2") {

				@attc_file = sort split(/\0/,$setup2{'img'});
				$photo = "<a href=$bbsname?category=$in{'category'}&file=$filename><img src=\"list.cgi?cmd=img&category=$in{'category'}&goods=$filename&filename=$attc_file[0]\" $width1 $height1 border=0></a>";
			}
			else {
				$photo = "<img src=\"$setup{'htdocs_url'}photo.gif\" width=17 height=12 alt=\"\">";
			}
		}
		else {
			if ($in{'mode'} eq "1" || $in{'mode'} eq "2") {

				$photo = "<img src=\"$setup{'htdocs_url'}sp.gif\" $width1 $height1 width=1>";
			}
			else { $photo = ""; }
		}

		if ($in{'cmd'} eq "memory") {

			$memodel = " <font size=-1>[<a class=n href=\"list.cgi?cmd=remember&action=delete&category=$in{'category'}&file=$filename\">폜</a>]</font>";
			$memodelAll = "<div align=center>[<a href=\"#\" onClick=\"window.external.addFavorite('$setup{'cgi_url'}list.cgi?cmd=memory','$barTitle ƂŌ锃Xg')\">ubN}[N</a>]\n";
			$memodelAll .= "[<a class=n href=\"list.cgi?cmd=remember&action=delall\">ׂč폜</a>]</div>";
		}
		else { $memodel = ""; }

		$setup2{'Title'} =~ s/\n//g;

		if ($in{'mode'} eq "1") { # 摜

			if ($setup2{'Rev'}) { $bgcolor = " bgcolor=#ffff99"; }
			else { $bgcolor = ""; }

			print "<tr><td colspan=3>\n";
			print "<table width=100% cellpadding=3 cellspacing=0 border=0>\n";
			print "<tr bgcolor=#dddddd><td width=90%>$bold1<a class=n href=$bbsname?category=$in{'category'}&file=$filename>$setup2{'Title'}</a>$bold2$memodel</td><td align=right nowrap width=10%>$setup2{'Fee'} $yen</td></tr>\n";
			print "<tr$bgcolor><td colspan=2>$photo</td></tr>\n";
			print "</table>\n";
			print "</td></tr>\n";
		}
		elsif ($in{'mode'} eq "2") { # 摜̂

			if (length($setup2{'Title'}) > 18) { $Title = &z_substr($setup2{'Title'},0,18) . '..'; }
			else { $Title = $setup2{'Title'}; }

			if ($setup2{'Rev'}) { $bgcolor = " bgcolor=#ffff99"; }
			else { $bgcolor = ""; }

			$colspan ++;
			if ($colspan > 5) { print "</tr><tr>\n"; $colspan = 1; }

			print "<td colspan=3 align=center>\n";
			print "<table cellpadding=3 cellspacing=0 border=0 height=100%>\n";
			print "<tr$bgcolor><td align=center>$photo</td></tr>\n";
			print "<tr$bgcolor><td align=center nowrap><small>$bold1<a class=n href=$bbsname?category=$in{'category'}&file=$filename>$Title</a>$bold2$memodel</small></td></tr>\n";
			print "<tr$bgcolor><td align=center nowrap>$setup2{'Fee'}$yen</td></tr>\n";
			print "</table>\n";
			print "</td>\n";
		}
		else {
			if ($setup2{'Rev'}) { $bgcolor = " bgcolor=#ffff99"; }
			else { $bgcolor = " bgcolor=$col[$col % 2]"; }

			print "<tr$bgcolor><td align=center>$photo</td>\n";
			print "<td>$bold1<a class=n href=$bbsname?category=$in{'category'}&file=$filename>$setup2{'Title'}</a>$bold2$memodel</td>\n";
			print "<td align=right nowrap>$setup2{'Fee'} $yen</td></tr>\n";
		}

		$br = "";
	}
	else {
		@list = ();
		if (eval { opendir(DIR,"$targetDir$filename"); }, $@ eq "") {

			@list = readdir(DIR);
			close(DIR);
			$kazu = @list - 2;

			foreach $dir (@list) {

				next if $dir eq '.';
				next if $dir eq '..';

				push(@array,"$filename/$dir");
			}

			if ($kazu > 0) { $kazu2 = " <font color=#888888>($kazu)</font>"; }
			else { $kazu2 = ""; }
		}

		if ($kazu == 0) {

			print "<tr bgcolor=#eeeeee><td><table><tr><td nowrap><b>$cateName{$filename}</b>$kazu2</td></tr></table></td></tr>\n";
		}
		else {
			print "<tr bgcolor=#eeeeee><td onMouseover=\"this.style.backgroundColor='#ffffff'\" onMouseout=\"this.style.backgroundColor='#eeeeee'\"><table><tr><td nowrap><a class=n href=$bbsname?category=$filename><b>$cateName{$filename}</b></a>$kazu2</td></tr></table></td></tr>\n";
		}

		$br = "<br>\n";
	}
}

if ($in{'mode'} eq "2") { print "</tr>\n"; }

print <<"EOF";
</table>
<font size=-1>
$memodelAll
</font>
</td>
EOF

if ($in{'cmd'} eq "memory" && !@NEW) {

print <<"EOF";
<td bgcolor=#$bgcolor{'panel'} vAlign=top width=70%><br><font color=#$textcolor{'panel'}><ul><li>ۗXg͂܂B<li>ɓɂ́AuȉvE [ ۗXgɒǉ ] NbN܂B<li>ŌɏiĂVԒxL܂B</ul></font></td>
EOF

}

if ($in{'category'} eq "" && ($in{'cmd'} ne "memory" || $in{'cmd'} eq "search")) {

print <<"EOF";
<td bgcolor=#$bgcolor{'panel'} vAlign=top width=70%><font color=#$textcolor{'panel'}>$main</font></td>
EOF

}

print <<"EOF";
</tr>
EOF

# _\
if ($in{'category'} eq "" && $in{'cmd'} ne "memory") {

	&getCate;

	srand(time|$$);
	@new = ();

	while (@array) {

		push(@new,splice(@array,rand @array,1));
	}

	$i = 0;
	foreach $new (@new) {

		($category,$filename) = split(/\//,$new,2);

		if (! open(F,"$goods_dir$category/$filename/index.cgi")) { next; }
		@lines = <F>;
		close(F);

		undef %setup2;
		foreach $line (@lines) {

			$line =~ s/\n//g;
			($key,$val) = split(/\t/,$line,2);
			$setup2{$key} .= "\0" if (defined($setup2{$key}));
			$setup2{$key} .= $val;
		}

		$setup2{'Fee'} = &keta($setup2{'Fee'});
		$setup2{'Fee'} = &keta($setup2{'Fee'});

		$setup2{'Title'} =~ s/\n//g;
		if (length($setup2{'Title'}) > 18) { $Title = &z_substr($setup2{'Title'},0,18) . '..'; }
		else { $Title = $setup2{'Title'}; }

		if ($setup2{'img'}) {

			@attc_file = sort split(/\0/,$setup2{'img'}); $attc_file[0] =~ s/\n//g;
			$photo = "<a href=$bbsname?category=$category&file=$filename><img src=\"list.cgi?cmd=img&category=$category&goods=$filename&filename=$attc_file[0]\" $width1 $height1 border=0></a>";
		}
		else { next; }

		$sample .= "<td colspan=3 align=center>\n";
		$sample .= "<table cellpadding=3 cellspacing=0 border=0 height=100%>\n";
		$sample .= "<tr><td align=center><small><a class=n href=$bbsname?category=$category>$cateName{$category}</a></small></td></tr>\n";
		$sample .= "<tr><td align=center>$photo</td></tr>\n";
		$sample .= "<tr><td align=center nowrap><small>$bold1<a class=n href=$bbsname?category=$category&file=$filename>$Title</a>$bold2</small></td></tr>\n";
		$sample .= "<tr><td align=center nowrap><small>$setup2{'Fee'}$yen</small></td></tr>\n";
		$sample .= "</table>\n";
		$sample .= "</td>\n";

		$i++;
		if ($i > 4) { last; }
	}

print <<"EOF";
<tr><td colspan=2 align=center><br><hr size=1><table width=80%><tr>$sample</tr></table></td></tr>
EOF

}

print <<"EOF";
<tr><td bgcolor=#$bgcolor{'panel'} colspan=3>$test<img src="$setup{'htdocs_url'}sp.gif" height=1 alt=""></td></tr>
</table>
EOF

if ($in{'category'} ne "" && $in{'cmd'} ne "memory" && $in{'cmd'} ne "search") {

print <<"EOF";
<table width=100% cellpadding=1 cellspacing=0>
<tr><td><img src="$setup{'htdocs_url'}sp.gif" height=1 alt=""></td></tr>
<tr bgcolor=#ffffff><td align=center><font color=#888888 size=-1>S<b>$in{'allhits'}</b><b>$FROM</b>\-<b>$LAST</b>(y[WNo.<b>$page_now</b>)</font></td></tr>
<tr><td><img src="$setup{'htdocs_url'}sp.gif" height=1 alt=""></td></tr>
</table>

<table width=100%>
<tr>
EOF

if ($in{'vp'} eq "") { $in{'vp'} = 1; }
print "<td align=center><font color=#$textcolor{'panel'}>[ ";

$start = $in{'vp'} - 9;
if ($start < 1) { $start = 1; }
elsif ($start == 1) { ; }
elsif ($start > 2) { print "<font size=+2><a class=n href=\"$bbsname?mode=$in{'mode'}\" title=\"ŏ̃y[W\">1</a></font> .."; }
else { print "<font size=+2><a class=n href=\"$bbsname?mode=$in{'mode'}\" title=\"ŏ̃y[W\">1</a></font>"; }

$end = $in{'vp'} + 9;
if ($end >= $last_page) { $end = $last_page; }
elsif ($end < $last_page - 1) { $last_link = " .. <font size=+2><a class=n href=\"$bbsname?n=$in{'n'}&vp=$last_page&allhits=$in{'allhits'}&ff=$ffv&mode=$in{'mode'}\">$last_page</a></font>\n"; }
else { $last_link = " <font size=+2><a class=n href=\"$bbsname?n=$in{'n'}&vp=$last_page&allhits=$in{'allhits'}&ff=$ffv&mode=$in{'mode'}\">$last_page</a></font>\n"; }

$n = $vp = 0;
foreach $vp ($start .. $end) {

	$ffv = ($vp - 1) * $page;
	$title = '';

	if ($vp == $in{'vp'}) { print " <b><font size=+1>$vp</font></b>"; $n = 1; $page_now = $vp; }
	elsif ($vp == 1) { print "<font size=+2><a class=n href=\"$bbsname?category=$in{'category'}&mode=$in{'mode'}\" title=\"ŏ̃y[W\">1</a></font> "; }
	else {
		if ($n) {

			$n = 0;
			$Next_link = "<a class=n href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$vp&allhits=$in{'allhits'}&ff=$ffv&mode=$in{'mode'}\"><font size=+1><b></b></a></font>";
			$next = $vp;
		}
		else { $next = $vp; }

		print " <font size=+2><a class=n href=\"$bbsname?category=$in{'category'}&cmd=$in{'cmd'}&vp=$vp&allhits=$in{'allhits'}&ff=$ffv&mode=$in{'mode'}\">$next</a></font>";
	}
}

print "$last_link ]";
print "&nbsp;&nbsp;$Next_link</font></td>\n";

print <<"EOF";
</tr></table>
EOF

}

print <<"EOF";
</td>
</tr></Table></td>
</tr></Table>
<!-- TopicWindow Area */-->
</td>
</tr>
</table></td>
</tr>
</table>
<!-- TopicWindow */ -->

<table cellspacing=0 width=80%>
<tr><td><img src="$setup{'htdocs_url'}sp.gif" height=2 alt=""></td></tr>
<tr>
<td align=center><font size=-1>
<a class=n href="list.cgi?cmd=tokushoho" target=popup onClick="popup()">菤@ɊÂ\\</a>
|
<a class=n href="list.cgi?cmd=payment" target=popup onClick="popup()">x@ɂ</a></font>
</td></tr>
<tr><td>$foot</td></tr></table>
<p>
</center>
</body></html>
EOF

exit;

}


sub error {

	local (@msg) = @_;
	local ($i);


print &HtmlTop("bgcolor=#FFFFFF");

print <<"EOF";

<STYLE type="text/css">
<!--
a.n:link { color:#$linkcolor{'panel'} }
a.n:visited { color:#$linkcolor{'panel'} }
a.n:hover { color:#$linkcolor{'panel'} }
a.n:active { color:#$linkcolor{'panel'} }
-->
</STYLE>

<!-- /* TopicWindow -->
<center>
<table cellpadding=0 cellspacing=0 border=0 width=80%>
<tr>
<td><table cellpadding=0 cellspacing=0 border=0>
<tr>
<td bgcolor=#$barbgcolor{'panel'} height=15 rowspan=2 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#$bartextcolor{'panel'}>$msg[0]</font>&nbsp;</td>
<td valign=top bgcolor=#$barbgcolor{'panel'}><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
<td align=right width=99% bgcolor=#FFFFFF><img src="$setup{'htdocs_url'}sp.gif" width=5 height=1 alt=""></td>
</tr>
<tr>
<td colspan=4 bgcolor=#$barbgcolor{'panel'} height=2></td>
</tr>
</table></td>
</tr>
<tr>
<td><table cellpadding=1 cellspacing=0 border=0 width=100%>
<tr bgcolor=#$barbgcolor{'panel'}>
<td><table cellpadding=10 cellspacing=0 border=0 width=100%>
<tr bgcolor=#$bgcolor{'panel'}>
<td>
<!-- /* TopicWindow Area-->
<br>
EOF

print "<ul>\n";
foreach $i (1 .. $#msg) { print "<li><font color=#$textcolor{'panel'}>$msg[$i]</font>\n"; }
print "</ul><p>\n";

if ($in{'cmd'} eq "memory") {

print <<"EOF";
<font color=#$textcolor{'panel'}>[</font> <a class=n href="$list_url">i</a> <font color=#$textcolor{'panel'}>]</font>
EOF

}
else {

print <<"EOF";
<font color=#$textcolor{'panel'}>[</font> <a class=n href="$list_url">ǂ</a> <font color=#$textcolor{'panel'}>]</font>
EOF

}

print <<"EOF";
<!-- TopicWindow Area */-->
</td>
</tr>
</table></td>
</tr>
</table></td>
</tr>
</table>
<!-- TopicWindow */ -->
</center>
EOF

print &HtmlBot;
exit;

}

sub error2 {

	local (@msg) = @_;
	local ($i);


print &HtmlTop("bgcolor=#FFFFFF");

print <<"EOF";

<STYLE type="text/css">
<!--
a.n:link { color:#$linkcolor{'panel'} }
a.n:visited { color:#$linkcolor{'panel'} }
a.n:hover { color:#$linkcolor{'panel'} }
a.n:active { color:#$linkcolor{'panel'} }
-->
</STYLE>

<!-- /* TopicWindow -->
<center>
<table cellpadding=0 cellspacing=0 border=0 width=80%>
<tr>
<td><table cellpadding=0 cellspacing=0 border=0>
<tr>
<td bgcolor=#$barbgcolor{'panel'} height=15 rowspan=2 nowrap><img src="$setup{'htdocs_url'}sp.gif" width=140 height=1><br>
&nbsp;&nbsp;<font color=#$bartextcolor{'panel'}>$msg[0]</font>&nbsp;</td>
<td valign=top bgcolor=#$barbgcolor{'panel'}><img src="$setup{'htdocs_url'}sp14x15.gif" width=14 height=15></td>
<td align=right width=99% bgcolor=#FFFFFF><img src="$setup{'htdocs_url'}sp.gif" width=5 height=1 alt=""></td>
</tr>
<tr>
<td colspan=4 bgcolor=#$barbgcolor{'panel'} height=2></td>
</tr>
</table></td>
</tr>
<tr>
<td><table cellpadding=1 cellspacing=0 border=0 width=100%>
<tr bgcolor=#$barbgcolor{'panel'}>
<td><table cellpadding=10 cellspacing=0 border=0 width=100%>
<tr bgcolor=#$bgcolor{'panel'}>
<td>
<!-- /* TopicWindow Area-->
<br>
EOF

print "<ul>\n";
foreach $i (1 .. $#msg) { print "<li><font color=#$textcolor{'panel'}>$msg[$i]</font>\n"; }
print "</ul><p>\n";

if ($in{'cmd'} eq "memory") {

print <<"EOF";
<font color=#$textcolor{'panel'}>[</font> <a class=n href="$list_url">i</a> <font color=#$textcolor{'panel'}>]</font>
EOF

}
else {

print <<"EOF";
<font color=#$textcolor{'panel'}>[</font> <a class=n href="$list_url">ǂ</a> <font color=#$textcolor{'panel'}>]</font>
EOF

}

print <<"EOF";
<!-- TopicWindow Area */-->
</td>
</tr>
</table></td>
</tr>
</table></td>
</tr>
</table>
<!-- TopicWindow */ -->
</center>
EOF

print &HtmlBot;
exit;

}

##
#### Spݗpsubstr() # oT Perl Tips <akebi.jp> by  for Shift_JIS
##

sub z_substr {

	local($s,$p,$l) = @_;
	$s =~ s/(.)/$1\0/g;
	$s =~ s/([\x81-\x9f\xe0-\xfc])\0(.)\0/$1$2\0\0/g;
	$s = $l eq '' ? substr($s,$p*2):substr($s,$p*2,$l*2);
	$s =~ tr/\0//d;
	$s;
}
